#! /usr/bin/env python

import argparse, os, sys, subprocess

versions = ['CPU', 
            'CPU_OpenMP', 
            'Cuda', 
            'OpenCL', 
            'Cuda_reduction', 
            'OpenCL_reduction']
            
parser = argparse.ArgumentParser()
parser.add_argument('--n', type=int, default=100000000)
parser.add_argument('--version', 
                    nargs="*", 
                    choices=versions,
                    default=versions)
args = parser.parse_args()

results = {}
couleurs = {'alloc': 'red', 'copy' : 'blue', 'compile' : 'green',
          'init' : 'yellow', 'add'  : 'back', 'verif'   : 'violet',
          'free' : 'cyan'
         }

for v in args.version:
    results[v] = []
    e = os.environ.copy()
    if v == 'CPU_OpenMP':
        e['OMP_NUM_THREADS'] = '8'

    subprocess.call([os.path.join('install', 'addition_' + v), str(args.n)],
                    env=e)
    
    with open(outFileName) as resFile:
      for l in resFile:
        print(l)
        w = l.split()
        if len(w) > 0 and w[0].endswith(':'):
          key = w[0][:-1]
          val = float(w[1])
          results[v].append([key, val])
print(results)
          
    
