#define IN_MAIN

#include <cstdlib>
#include <iostream>
#include "calcul.hxx"
#include "timer.hxx"
#include "config.hxx"
#include "arguments.hxx"

#ifdef _OPENMP
#include <omp.h>
#endif

int main(int argc, char **argv)
{  
#ifdef _OPENMP
  std::cerr << "Version : CPU OpenMP (" 
            << omp_get_max_threads() << " thread(s) )" << std::endl;
#else
  std::cerr << "Compiler avec OpenMP" << std::endl;
  return -1;
#endif

  T_AllocId = AddTimer("alloc");
  T_InitId = AddTimer("init");
  T_AddId = AddTimer("add");
  T_VerifId = AddTimer("verif");
  T_FreeId = AddTimer("free");
  AddTimer("total");

  Arguments Args(argc, argv);
  size_t n = Args.Get("n", N);

  Timer & T_total = GetTimer(-1);
  T_total.start();
  
  double v;
  {
    Calcul_CPU C(n);
    C.init();
    C.addition();
    v = C.verification();
  }

  T_total.stop();

  std::cout << "erreur " << v << "\n"
	    << std::endl;
  
  PrintTimers(std::cout);
  SaveTimers("CPU_OpenMP");
  return 0;
}
