#define IN_MAIN

#include <cstdlib>
#include <iostream>
#include "calcul_OpenCL.hxx"
#include "timer.hxx"
#include "OpenCL.hxx"
#include "config.hxx"
#include "arguments.hxx"

int main(int argc, char **argv)
{  
  std::cerr << "Version : OpenCL (reduction sur GPU)" << std::endl;
  T_AllocId = AddTimer("alloc");
  T_CopyId = AddTimer("copy");
  T_CompileId = AddTimer("compile");
  T_InitId = AddTimer("init");
  T_AddId = AddTimer("add");
  T_VerifId = AddTimer("verif");
  T_FreeId = AddTimer("free");
  AddTimer("total");

  Arguments Args(argc, argv);
  unsigned long n = Args.Get("n", N);
    
  Timer & T_total = GetTimer(-1);
  T_total.start();
  
  double v;
  {
    Calcul_OpenCL C(n);
    C.init();
    C.addition();
    v = C.verification();
  }

  T_total.stop();

  std::cout << "erreur " << v << "\n" 
       << std::endl;

  PrintTimers(std::cout);
  SaveTimers("OpenCL_reduction");
  return 0;
}
