#define IN_MAIN

#include "timer.hxx"
#include "io_png.hxx"
#include "operation.h"
#include <stddef.h>
#include <iostream>
#include <string>
#include <filesystem>
#include "os.hxx"
#include "version.hxx"
#include "arguments.hxx"

const char pathSeparator =
#ifdef _WIN32
      '\\';
#else
      '/';
#endif

int main(int argc, char **argv)
{
  std::string appName = argv[0];
  appName = appName.substr(appName.find_last_of("/\\") + 1);
  appName = appName.substr(0, appName.find_last_of('.'));

  std::string device = std::string("Compute on ") + appName.substr(6,3);

  std::cerr << "_____________________\n" << appName << std::endl << std::endl;

  Timer T_global("Total");
  T_global.start();
  
  std::string fileIn, fileOut;
  cImage imageIn, imageOut;
 
  std::string defaultIn = "images";
  defaultIn += pathSeparator;
  defaultIn += "ecureuil.png";

  Arguments Args(argc, argv);
  fileIn = Args.Get("in", defaultIn);

  std::string defaultOut;
  defaultOut = "results";
  defaultOut += pathSeparator;
  defaultOut += version;
  std::size_t found = fileIn.rfind(pathSeparator);
  found = found == std::string::npos ? 0 : found+1;
  defaultOut += pathSeparator;
  defaultOut += fileIn.substr(found);

  fileOut = Args.Get("out", defaultOut);
  found = fileOut.find_last_of("/\\");
  std::string dirOut = fileOut.substr(0,found);

  std::filesystem::create_directories(dirOut);

  Timer T1("Read file ", 1), T2(device.c_str(), 1), T3("Write file", 1);
  T1.start();
  
  imageIn.read_png(fileIn.c_str());
  
  T1.stop();
  std::cerr << "\n" << T1 << std::endl;
  
  T2.start();
  
  process(imageOut, imageIn);
  
  T2.stop();
  std::cerr << "\n" << T2 << std::endl;
  
  T3.start();

  imageOut.write_png(fileOut.c_str());
  
  T3.stop();
  std::cerr << "\n" << T3 << std::endl;

  T_global.stop();
  std::cerr << "\n" << T_global << std::endl;

  return 0;
}
